from unicodedata import decimal
from eth_wallet import BaseWallet
from eth_wallet import Setting

class TokenClass:
    
    def __init__(self):
        self.client = BaseWallet.eth_chain_client()
    
    def add_token(self,token_name,token_address):
        """
        添加token

        :param token_name: _description_
        :param token_address: _description_
        """
        return Setting.yaml_insert('TOKEN-LIST',{'NAME':token_name,'ADDRESS':token_address})
    
    def get_balance(self,token_name):
        """
        获取代币余额

        :param token_name: _description_
        """
        if token_name == "eth":
            return self.client.get_balance(self.client.address)
        else:
            for i in self.get_token_list():
                if i['NAME'] == token_name:
                    __address = i['ADDRESS']
            return self.client.contract_fun(
                __address,
                "eth_wallet/conf/abi/erc20.json",
                self.client.private_key,
                "balanceOf",
                self.client.address,
                True
            )

    def get_token_list(self):
        """
        获取代币列表
        """
        return Setting.yaml_show('TOKEN-LIST')
        
    def get_decimals(self,token_name):
        """
        获取小数点
        """
        if token_name == "eth":
            return 18
        else:
            for i in self.get_token_list():
                if i['NAME'] == token_name:
                    __address = i['ADDRESS']
            return self.client.contract_fun(
                __address,
                "eth_wallet/conf/abi/erc20.json",
                self.client.private_key,
                "decimals",
                self.client.address,
                True
            )

    
    def send_transaction(self,msg_token_name,msg_to,msg_value):
        """
        发送交易
        """
        if msg_token_name == 'eth':
            return self.client.transfer_eth(msg_to,msg_value,self.client.private_key)
        else:
            for i in self.get_token_list():
                if i['NAME'] == msg_token_name:
                    __address = i['ADDRESS']
            decimal = self.get_decimals(msg_token_name)
            return self.client.contract_fun(
                __address,
                'eth_wallet/conf/abi/erc20.json',
                self.client.private_key,
                'transfer',
                (msg_to,int(float(msg_value)*10**int(decimal))),
                )