import click,os,sys

sys.path.append("/Users/yuexiao/xiaoyue2/aboutPython/aboutcmd2/")

from eth_wallet.TokenClass import (
    TokenClass
)
from eth_wallet.ToolsClass import (
    ToolsClass
)
from eth_wallet.WalletClass import (
    WalletClass
)

TokenClass = TokenClass()
ToolsClass = ToolsClass()
WalletClass = WalletClass()

@click.group()
def wallet():
    pass

@wallet.group()
def tools():
    """
    工具类
    """
    pass

@wallet.group()
def bwallet():
    """
    钱包类
    """
    pass

@wallet.group()
def token():
    """
    代币类
    """
    pass

@token.command()
@click.option('-n', '--name', default='', prompt='Contract name',
              help='Contract name.')
@click.option('-a', '--address', default='', prompt='Contract Address',
              help='Contract Address.')
def add(name,address):
    """
    增加token

    :param name: _description_
    :param address: _description_
    """
    click.echo(TokenClass.add_token(name,address))

@token.command()
@click.option('-n', '--name', default='', prompt='balance name',
              help='balance name.')
def balance(name):
    """
    获取余额

    :param name: _description_
    """
    click.echo(TokenClass.get_balance(name))

@token.command()
def list():
    """
    获取token列表
    """
    for i in TokenClass.get_token_list():
        click.echo("{}:{}".format(i['NAME'],i['ADDRESS']))

@token.command()
@click.option('-n', '--name', default='', prompt='msg_token_name',
              help='msg_token_name.')
@click.option('-t', '--to', default='', prompt='msg_to',
              help='msg_to.')
@click.option('-v', '--value', default='', prompt='msg_value',
              help='msg_value.')
def send_transaction(name,to,value):
    """
    发送交易

    :param msg_token_name: _description_
    :param msg_to: _description_
    :param msg_value: _description_
    """
    click.echo(TokenClass.send_transaction(name,to,value))


@bwallet.command()
def show():
    """
    获取钱包信息

    :return: _description_
    """
    click.echo(WalletClass.show_wallet())


@bwallet.command()
@click.option('-p', '--pwd', default='', prompt='password',
              help='password')
def create(pwd):
    """
    创建/重建钱包

    :param pwd: _description_
    :return: _description_
    """
    click.echo(WalletClass.create_wallet(pwd))

@bwallet.command()
@click.option('-pri', '--private', default='', prompt='private',
              help='private')
@click.option('-p', '--pwd', default='', prompt='password',
              help='password')
def recovery(private,pwd):
    """
    恢复钱包

    :param pri: _description_
    :param pwd: _description_
    :return: _description_
    """
    click.echo(WalletClass.recovery_wallet(private,pwd))

@tools.command()
def current():
    """
    查看当前网络
    """
    click.echo(ToolsClass.show_network())

@tools.command()
def update(network):
    """
    设置网络

    :param network: _description_
    """
    click.echo(ToolsClass.set_network(network))

if __name__ == '__main__':
    wallet()